<?php
if (!defined( 'ABSPATH' )) exit;
class woo2app_core_api_coupon {
	public function __construct(){
		add_action( 'init', array( $this , 'woo2app_api_regular_url' ));
		add_filter( 'query_vars', array( $this , 'woo2app_api_query_vars' ));
		add_action( 'parse_request', array( $this , 'woo2app_api_parse_request' ));
	}
	
    function woo2app_api_regular_url(){
		add_rewrite_rule('', 'index.php?woo2app_coupon', 'top');
	}
	function woo2app_api_query_vars($query_vars){
		$query_vars[] = 'woo2app_coupon';
		return $query_vars;
	}
	function woo2app_api_parse_request(&$wp){
		if ( array_key_exists( 'woo2app_coupon', $wp->query_vars ) ) {
	        $this->woo2app_coupon();
	        exit();
	    }
	    return;
	}

	function woo2app_coupon(){
			$in = $_POST['in'];
			$slashless = stripcslashes($in);
			$url_json = urldecode($slashless);
			$json = (array) json_decode($url_json);
			WC()->cart->empty_cart();
            if (!isset($json["items"])) {
                wp_send_json_error(array('error' => 'order required'), 400);
            }
            $line_items = $json["items"];
            $total_price = 0;
            $qtt = 0;
            foreach ($line_items as $product) {
                WC()->cart->add_to_cart($product->product_id, $product->quantity);
            }
			$cart = wc()->cart->get_cart();

			foreach($cart as $index => $value){
				$qtt += $value["quantity"];
				$total_price += $value["line_subtotal"];
			}
            if (!isset($json["coupon_code"])) {
                wp_send_json_error(array('error' => 'coupon code required'), 400);
            }
            $coupon_code = $json["coupon_code"];//$entity_body->coupon_code;
            $the_coupon = new WC_Coupon($coupon_code);
//-------------------------------------------------
            if (!$the_coupon->is_valid()) {
                if (!$the_coupon->exists) {
                    wp_send_json_error(array('error' => sprintf(__('Coupon "%s" does not exist!', 'woocommerce'), $coupon_code)), 400);
                }
                if ($the_coupon->usage_limit > 0 && $the_coupon->usage_count >= $the_coupon->usage_limit) {
                    wp_send_json_error(array('error' => __('Coupon usage limit has been reached.', 'woocommerce')), 400);
                }
                if ($the_coupon->expiry_date && current_time('timestamp') > $the_coupon->expiry_date) {
                    wp_send_json_error(array('error' => __('This coupon has expired.', 'woocommerce')), 400);
                }
                if ($the_coupon->minimum_amount > 0 && apply_filters('woocommerce_coupon_validate_minimum_amount', wc_format_decimal($the_coupon->minimum_amount) > $line_items[0]->line_subtotal, $this)) {
                    wp_send_json_error(array('error' => sprintf(__('The minimum spend for this coupon is %s.', 'woocommerce'), $the_coupon->minimum_amount)), 400);
                }
                if ($the_coupon->maximum_amount > 0 && apply_filters('woocommerce_coupon_validate_maximum_amount', wc_format_decimal($the_coupon->maximum_amount) < $line_items[0]->line_subtotal, $this)) {
                    wp_send_json_error(array('error' => sprintf(__('The maximum spend for this coupon is %s.', 'woocommerce'), $the_coupon->minimum_amount)), 400);
                }
                if (sizeof($the_coupon->product_ids) > 0) {
                    $valid_for_cart = false;
                    if (!$line_items) {
                        foreach ($line_items as $cart_item_key => $cart_item) {
                            if (in_array($cart_item->product_id, $the_coupon->product_ids) || in_array($cart_item->variation_id, $the_coupon->product_ids) || in_array($cart_item->data->get_parent(), $the_coupon->product_ids)) {
                                $valid_for_cart = true;
                            }
                        }
                    }
                    if (!$valid_for_cart) {
                        wp_send_json_error(array('error' => __('Sorry, this coupon is not applicable to your cart contents.', 'woocommerce')), 400);
                    }
                }
                if (sizeof($the_coupon->product_categories) > 0) {
                    $valid_for_cart = false;
                    if (!$line_items) {
                        foreach ($line_items as $cart_item_key => $cart_item) {
                            $product_cats = wc_get_product_cat_ids($cart_item->product_id);

                            // If we find an item with a cat in our allowed cat list, the coupon is valid
                            if (sizeof(array_intersect($product_cats, $the_coupon->product_categories)) > 0) {
                                $valid_for_cart = true;
                            }
                        }
                    }
                    if (!$valid_for_cart) {
                        wp_send_json_error(array('error' => __('Sorry, this coupon is not applicable to your cart contents.', 'woocommerce')), 400);
                    }
                }
                if ('yes' === $the_coupon->exclude_sale_items && $the_coupon->is_type(wc_get_product_coupon_types())) {
                    $valid_for_cart = false;
                    $product_ids_on_sale = wc_get_product_ids_on_sale();

                    if (!$line_items) {
                        foreach ($line_items as $cart_item_key => $cart_item) {
                            if (!empty($cart_item->variation_id)) {
                                if (!in_array($cart_item->variation_id, $product_ids_on_sale, true)) {
                                    $valid_for_cart = true;
                                }
                            } elseif (!in_array($cart_item->product_id, $product_ids_on_sale, true)) {
                                $valid_for_cart = true;
                            }
                        }
                    }
                    if (!$valid_for_cart) {
                        wp_send_json_error(array('error' => __('Sorry, this coupon is not valid for sale items.', 'woocommerce')), 400);
                    }
                }
                if (!$line_items && $the_coupon->is_type(wc_get_product_coupon_types())) {
                    $valid = false;

                    foreach ($line_items as $cart_item_key => $cart_item) {
                        if ($the_coupon->is_valid_for_product($cart_item->data, $cart_item)) {
                            $valid = true;
                            break;
                        }
                    }

                    if (!$valid) {
                        wp_send_json_error(array('error' => __('Sorry, this coupon is not applicable to your cart contents.', 'woocommerce')), 400);
                    }
                }
                if (!$the_coupon->is_type(wc_get_product_coupon_types())) {
                    if (sizeof($the_coupon->exclude_product_ids) > 0) {
                        $valid_for_cart = true;
                        if (!$line_items) {
                            foreach ($line_items as $cart_item_key => $cart_item) {
                                if (in_array($cart_item->product_id, $the_coupon->exclude_product_ids) || in_array($cart_item->variation_id, $the_coupon->exclude_product_ids) || in_array($cart_item->data->get_parent(), $the_coupon->exclude_product_ids)) {
                                    $valid_for_cart = false;
                                }
                            }
                        }
                        if (!$valid_for_cart) {
                            $products = array();
                            if (!$line_items) {
                                foreach ($line_items as $cart_item_key => $cart_item) {
                                    if (in_array($cart_item->product_id, $the_coupon->exclude_product_ids) || in_array($cart_item->variation_id, $the_coupon->exclude_product_ids) || in_array($cart_item->data->get_parent(), $the_coupon->exclude_product_ids)) {
                                        $product = wc_get_product($cart_item->product_id);
                                        $products[] = $product->get_title();
                                    }
                                }
                            }

                            wp_send_json_error(array('error' => sprintf(__('Sorry, this coupon is not applicable to the products: %s.', 'woocommerce'), implode(', ', $products))), 400);
                        }
                    }
                    if (sizeof($the_coupon->exclude_product_categories) > 0) {
                        $valid_for_cart = true;
                        if ($line_items) {
                            foreach ($line_items as $cart_item_key => $cart_item) {

                                $product_cats = wc_get_product_cat_ids($cart_item->product_id);

                                if (sizeof(array_intersect($product_cats, $the_coupon->exclude_product_categories)) > 0) {
                                    $valid_for_cart = false;
                                }
                            }
                        }
                        if (!$valid_for_cart) {
                            $categories = array();
                            if ($line_items) {
                                foreach ($line_items as $cart_item_key => $cart_item) {
                                    $product_cats = wc_get_product_cat_ids($cart_item->product_id);

                                    if (sizeof($intersect = array_intersect($product_cats, $the_coupon->exclude_product_categories)) > 0) {

                                        foreach ($intersect as $cat_id) {
                                            $cat = get_term($cat_id, 'product_cat');
                                            $categories[] = $cat->name;
                                        }
                                    }
                                }
                            }

                            wp_send_json_error(array('error' => sprintf(__('Sorry, this coupon is not applicable to the categories: %s.', 'woocommerce'), implode(', ', array_unique($categories)))), 400);
                        }
                    }
                    if ($the_coupon->exclude_sale_items == 'yes') {
                        $valid_for_cart = true;
                        $product_ids_on_sale = wc_get_product_ids_on_sale();
                        if ($line_items) {
                            foreach ($line_items as $cart_item_key => $cart_item) {
                                if (!empty($cart_item->variation_id)) {
                                    if (in_array($cart_item->variation_id, $product_ids_on_sale, true)) {
                                        $valid_for_cart = false;
                                    }
                                } elseif (in_array($cart_item->product_id, $product_ids_on_sale, true)) {
                                    $valid_for_cart = false;
                                }
                            }
                        }
                        if (!$valid_for_cart) {
                            wp_send_json_error(array('error' => __('Sorry, this coupon is not valid for sale items.', 'woocommerce')), 400);
                        }
                    }
                }
            } else {
                switch ($the_coupon->discount_type) {
                    case 'fixed_cart':
                        $price = $the_coupon->coupon_amount;
                        break;
                    case 'percent':
                        $price = $total_price * ($the_coupon->coupon_amount / 100);
                        break;
                    case 'fixed_product':
                        $price = $qtt * $the_coupon->coupon_amount;
                        break;
                    case 'percent_product':
                        $price = $total_price * ($the_coupon->coupon_amount / 100);
                        break;
                }
                wp_send_json_success(array('code' => $the_coupon->code, 'id' => $the_coupon->id, 'amount' => $price));
            }
            wp_send_json_error(array('error' => __('coupon not valid!', 'woo2app')), 400);
		    
	}

}