<?php
if (!defined( 'ABSPATH' )) exit;
class woo2app_core_api_setting {
	public function __construct(){
		add_action( 'init', array( $this , 'woo2app_api_regular_url' ));
		add_filter( 'query_vars', array( $this , 'woo2app_api_query_vars' ));
		add_action( 'parse_request', array( $this , 'woo2app_api_parse_request' ));
	}
	function woo2app_api_regular_url(){
		add_rewrite_rule('', 'index.php?GET_setting', 'top');
	}
	function woo2app_api_query_vars($query_vars){
		$query_vars[] = 'GET_setting';
		return $query_vars;
	}
	function woo2app_api_parse_request(&$wp){
		if ( array_key_exists( 'GET_setting', $wp->query_vars ) ) {
	        $this->woo2app_GET_setting();
	        exit();
	    }
	    return;
	}
	function woo2app_GET_setting(){
		header('Content-Type: application/json; charset=utf-8');
		ob_start();
		$mainpage_json = $this->get_mainpage();
		$slider_json = $this->get_slider();
		$menu_json = $this->get_menu();
		$setting_json = $this->get_setting();
		$data_zone = $this->get_default_data();
		$array_all_setting =  array(
			'main_page' => $mainpage_json, 
			'slider' => $slider_json, 
			'menu' => $menu_json, 
			'shop_setting' => $setting_json ,
			'states' => $data_zone
		);
		ob_clean();
		echo json_encode($array_all_setting);
	}
	private function get_mainpage(){
		global $wpdb;
		$table_name = $wpdb->prefix . "woo2app_mainpage";
		$rec = $wpdb->get_results("select * from $table_name ORDER BY mp_order ASC");
		$array = array();
		foreach ($rec as $key ) {
			if ($key->mp_showtype == 4) {
				$slashless = stripcslashes($key->mp_value);
			}else{
				$slashless = $key->mp_value;
			}
			$array[] = array(
							"type" => $key->mp_showtype,
							"action" => $key->mp_type,
							"value" => $slashless,
							"title" => $key->mp_title,
							"pic" => $key->mp_pic,
							"order" => $key->mp_order
						);
		}
		return $array;
	}
	private function get_slider(){
		global $wpdb;
		$table_name = $wpdb->prefix . "woo2app_slider";
		$rec = $wpdb->get_results("select * from $table_name");
		$array = array();
		foreach ($rec as $key ) {
			$array[] = array(
							"action" => $key->sl_type,
							"value" => $key->sl_value,
							"title" => $key->sl_title,
							"pic" => $key->sl_pic
							);
		}
		return $array;
	}
	private function get_menu(){
		global $wpdb;
		$table_name = $wpdb->prefix . "woo2app_menu";
		$rec = $wpdb->get_results("select * from $table_name where menu_menu = 1 ORDER BY menu_order ASC");
		$array = array();
		foreach ($rec as $key) {
			$array[] = array(
							"action" => $key->menu_action,
							"value" => $key->menu_value,
							"title" => $key->menu_title,
							"pic" => $key->menu_pic,
							"order" => $key->menu_order
							);	
		}
		$rec1 = $wpdb->get_results("select * from $table_name where menu_menu = 2 ORDER BY menu_order ASC");
		$array1 = array();
		foreach ($rec1 as $key) {
			$array1[] = array(
							"action" => $key->menu_action,
							"value" => $key->menu_value,
							"title" => $key->menu_title,
							"pic" => $key->menu_pic,
							"order" => $key->menu_order
							);	
		}
		$arraymenu1 = array(
			'position' => get_option("NUM_MENU1_POS"),
			'items'    => $array
			);
		$arraymenu2 = array(
			'position' => get_option("NUM_MENU2_POS"),
			'items'    => $array1
			);
		return $arrayName = array( $arraymenu1 , $arraymenu2 );
	}
	private function get_setting(){
		$arraysetting = array(
			//**************general****************************************
			$arrayName = array('key' => 'URL_SPLASH_PIC' , 'value' => get_option("URL_SPLASH_PIC") ) ,
			
			$arrayName = array('key' => 'NUM_SPLASH_DELAY' , 'value' => get_option("NUM_SPLASH_DELAY") ) ,
			
			$arrayName = array('key' => 'COLOR_GENERAL_ACTIONBAR_BG' , 'value' => get_option("COLOR_GENERAL_ACTIONBAR_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_GENERAL_STATUSBAR_BG' , 'value' => get_option("COLOR_GENERAL_STATUSBAR_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_GENERAL_MAIN_BG' , 'value' => get_option("COLOR_GENERAL_MAIN_BG") ) ,
			
			$arrayName = array('key' => 'NUM_MENU1_POS' , 'value' => get_option("NUM_MENU1_POS") ) ,
			
			$arrayName = array('key' => 'NUM_MENU2_POS' , 'value' => get_option("NUM_MENU2_POS") ) ,
			//************primary*******************************************
			
			$arrayName = array('key' => 'COLOR_CATLISTBUTTON_BG' , 'value' => get_option("COLOR_CATLISTBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_CATLISTBUTTON_TEXT' , 'value' => get_option("COLOR_CATLISTBUTTON_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_MOREBUTTON_BG' , 'value' => get_option("COLOR_MOREBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_MOREBUTTON_TEXT' , 'value' => get_option("COLOR_MOREBUTTON_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCTCELL_BG' , 'value' => get_option("COLOR_PRODUCTCELL_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCTCELL_TITLE_TEXT' , 'value' => get_option("COLOR_PRODUCTCELL_TITLE_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCTCELL_PRICE_TEXT' , 'value' => get_option("COLOR_PRODUCTCELL_PRICE_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCTCELL_OFFPRICE_TEXT' , 'value' => get_option("COLOR_PRODUCTCELL_OFFPRICE_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_MENU_BG' , 'value' => get_option("COLOR_MENU_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_MENU_TEXT' , 'value' => get_option("COLOR_MENU_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_LIST_PRICE_DEVIDER_BG' , 'value' => get_option("COLOR_LIST_PRICE_DEVIDER_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_MENU_FLOT_BG' , 'value' => get_option("COLOR_MENU_FLOT_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_LIST_TITLE_TEXT' , 'value' => get_option("COLOR_LIST_TITLE_TEXT") ) ,
			//***********bascket***********************************************
			
			$arrayName = array('key' => 'COLOR_BASKET_LIST_BG' , 'value' => get_option("COLOR_BASKET_LIST_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_P_TITLE_TEXT' , 'value' => get_option("COLOR_BASKET_P_TITLE_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_PRICEVAHED_TEXT' , 'value' => get_option("COLOR_BASKET_PRICEVAHED_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_PRICEVAHED_BG' , 'value' => get_option("COLOR_BASKET_PRICEVAHED_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_PRICEKOL_TEXT' , 'value' => get_option("COLOR_BASKET_PRICEKOL_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_PRICEKOL_BG' , 'value' => get_option("COLOR_BASKET_PRICEKOL_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_DEL_TEXT' , 'value' => get_option("COLOR_BASKET_DEL_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_DEL_BG' , 'value' => get_option("COLOR_BASKET_DEL_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_TOTAL_TEXT' , 'value' => get_option("COLOR_BASKET_TOTAL_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_TOTAL_BG' , 'value' => get_option("COLOR_BASKET_TOTAL_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_COMPLETEORDER_BG' , 'value' => get_option("COLOR_COMPLETEORDER_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_COMPLETEORDER_TEXT' , 'value' => get_option("COLOR_COMPLETEORDER_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_BASKET_COUNT_TEXT' , 'value' => get_option("COLOR_BASKET_COUNT_TEXT") ) ,
			//***********product**************************************************
			
			$arrayName = array('key' => 'COLOR_ADDCARD_BG' , 'value' => get_option("COLOR_ADDCARD_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_ADDCARD_TEXT' , 'value' => get_option("COLOR_ADDCARD_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCTGALLERY_BG' , 'value' => get_option("COLOR_PRODUCTGALLERY_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUC_TTITLE_TEXT' , 'value' => get_option("COLOR_PRODUC_TTITLE_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCT_PRICE_TEXT' , 'value' => get_option("COLOR_PRODUCT_PRICE_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_PRODUCT_PRICEOFF_TEXT' , 'value' => get_option("COLOR_PRODUCT_PRICEOFF_TEXT") ) ,
			//**********desc order*********************************************
			
			$arrayName = array('key' => 'COLOR_DETAILO_PAYBUTTON_BG' , 'value' => get_option("COLOR_DETAILO_PAYBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_DETAILO_PAYBUTTON_TEXT' , 'value' => get_option("COLOR_DETAILO_PAYBUTTON_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_DETAILO_PAYDES_TEXT' , 'value' => get_option("COLOR_DETAILO_PAYDES_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_DETAILO_PAYDES_BG' , 'value' => get_option("COLOR_DETAILO_PAYDES_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_DETAILO_PAYITEM_BG' , 'value' => get_option("COLOR_DETAILO_PAYITEM_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_DETAILO_PAYITEM_TEXT' , 'value' => get_option("COLOR_DETAILO_PAYITEM_TEXT") ) ,
			//*********submit order************************************
			
			$arrayName = array('key' => 'COLOR_SUBTMIORDER_BG' , 'value' => get_option("COLOR_SUBTMIORDER_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_SUBMITORDER_TEXT' , 'value' => get_option("COLOR_SUBMITORDER_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_SUBMITORDER_ACCONT_TEXT' , 'value' => get_option("COLOR_SUBMITORDER_ACCONT_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_SUBMITORDER_TOTAL_TEXT' , 'value' => get_option("COLOR_SUBMITORDER_TOTAL_TEXT") ) ,
			//********register*****************************************
			
			$arrayName = array('key' => 'COLOR_REGISTERBUTTON_BG' , 'value' => get_option("COLOR_REGISTERBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_REGISTERBUTTON_TEXT' , 'value' => get_option("COLOR_REGISTERBUTTON_TEXT") ) ,
			//*******edit user**************************************
			
			$arrayName = array('key' => 'COLOR_EDITUSERBUTTON_BG' , 'value' => get_option("COLOR_EDITUSERBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_EDITUSERBUTTON_TEXT' , 'value' => get_option("COLOR_EDITUSERBUTTON_TEXT") ) ,
			//***********login***************************************
			
			$arrayName = array('key' => 'COLOR_LOGINBUTTON_BG' , 'value' => get_option("COLOR_LOGINBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_LOGINBUTTON_TEXT' , 'value' => get_option("COLOR_LOGINBUTTON_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_LOGIN_FORGETPPASS_TEXT' , 'value' => get_option("COLOR_LOGIN_FORGETPPASS_TEXT") ) ,
			
			$arrayName = array('key' => 'COLOR_LOGIN_REGISTER_TEXT' , 'value' => get_option("COLOR_LOGIN_REGISTER_TEXT") ) ,
			//*************change pass******************************
			
			$arrayName = array('key' => 'COLOR_CHANGEPASS_BG' , 'value' => get_option("COLOR_CHANGEPASS_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_CHANGEPASS_TEXT' , 'value' => get_option("COLOR_CHANGEPASS_TEXT") ) ,
			//***********forgot pass*****************************
			
			$arrayName = array('key' => 'COLOR_FORGETBUTTON_BG' , 'value' => get_option("COLOR_FORGETBUTTON_BG") ) ,
			
			$arrayName = array('key' => 'COLOR_FORGETBUTTON_TEXT' , 'value' => get_option("COLOR_FORGETBUTTON_TEXT") ) ,
			
			$arrayName = array('key' => 'SHOW_BTN_CATLST' , 'value' => get_option("SHOW_BTN_CATLST") ) ,
			//***********primary setting*******************************************************************
			$arrayName = array('key' => 'DEFAULT_BROWSER_IN' , 'value' => get_option("DEFAULT_BROWSER_IN") ) ,
			
			$arrayName = array('key' => 'DEFAULT_FONT_APP' , 'value' => get_option("DEFAULT_FONT_APP") ) ,
			
			$arrayName = array('key' => 'DEFAULT_UNIT_APP' , 'value' => get_option("DEFAULT_UNIT_APP") ) ,			
			$arrayName = array('key' => 'DEFAULT_LNK_APP' , 'value' => get_option("DEFAULT_LNK_APP") ) ,			
			$arrayName = array('key' => 'DEFAULT_VER_APP' , 'value' => get_option("DEFAULT_VER_APP") ) ,			
	 	);
	
		return $arraysetting;
	}


	function get_default_data(){
	
		global $woocommerce;
            $countries_obj   = new WC_Countries();
            $countries   = $countries_obj->__get('countries');
            $default_country = $countries_obj->get_base_country();
            $default_county_states = $countries_obj->get_states( $default_country );
            $states = array();
            foreach ($default_county_states as $key=>$state) {
                $states[]= array(
                    'id'    => $key,
                    'name'  => $state
                );
                //echo $key.'+'.$state.'<br>';
            }

	        return $json['states'] = $states;

	}
}